3 # Copyright (c) 2005 Junio C Hamano
6 # For repeatability, reset the environment to known value.
11 export LANG LC_ALL PAGER TZ
17 unset COMMIT_AUTHOR_EMAIL
18 unset COMMIT_AUTHOR_NAME
20 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
22 GIT_AUTHOR_EMAIL=author@example.com
23 GIT_AUTHOR_NAME='A U Thor'
24 unset GIT_COMMITTER_DATE
25 GIT_COMMITTER_EMAIL=committer@example.com
26 GIT_COMMITTER_NAME='C O Mitter'
29 unset GIT_EXTERNAL_DIFF
31 unset GIT_OBJECT_DIRECTORY
32 unset SHA1_FILE_DIRECTORIES
33 unset SHA1_FILE_DIRECTORY
35 export GIT_MERGE_VERBOSITY
36 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
37 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
40 # Protect ourselves from common misconfiguration to export
41 # CDPATH into the environment
44 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
46 echo "* warning: Some tests will not work if GIT_TRACE" \
47 "is set as to trace on STDERR ! *"
48 echo "* warning: Please set GIT_TRACE to something" \
49 "other than 1, 2 or true ! *"
53 # Each test should start with something like this, after copyright notices:
55 # test_description='Description of this test...
56 # This test checks if command xyzzy does the right thing...
70 test "${test_description}" != "" ||
71 error "Test script did not set test_description."
76 -d|--d|--de|--deb|--debu|--debug)
78 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
80 -h|--h|--he|--hel|--help)
81 echo "$test_description"
83 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
94 if test "$verbose" = "t"
98 exec 4>/dev/null 3>/dev/null
104 trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
107 if test -z "${test_tick+set}"
111 test_tick=$(($test_tick + 60))
113 GIT_COMMITTER_DATE="$test_tick -0700"
114 GIT_AUTHOR_DATE="$test_tick -0700"
115 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
118 # You are not expected to call test_ok_ and test_failure_ directly, use
119 # the text_expect_* functions instead.
122 test_count=$(expr "$test_count" + 1)
123 say " ok $test_count: $@"
127 test_count=$(expr "$test_count" + 1)
128 test_failure=$(expr "$test_failure" + 1);
129 say "FAIL $test_count: $1"
131 echo "$@" | sed -e 's/^/ /'
132 test "$immediate" = "" || { trap - exit; exit 1; }
137 test "$debug" = "" || eval "$1"
147 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
148 this_test="$this_test.$(expr "$test_count" + 1)"
150 for skp in $GIT_SKIP_TESTS
159 say >&3 "skipping test: $@"
160 test_count=$(expr "$test_count" + 1)
161 say "skip $test_count: $1"
170 test_expect_failure () {
172 error "bug in the test script: not 2 parameters to test-expect-failure"
175 say >&3 "expecting failure: $2"
177 if [ "$?" = 0 -a "$eval_ret" != 0 -a "$eval_ret" -lt 129 ]
187 test_expect_success () {
189 error "bug in the test script: not 2 parameters to test-expect-success"
192 say >&3 "expecting success: $2"
194 if [ "$?" = 0 -a "$eval_ret" = 0 ]
204 test_expect_code () {
206 error "bug in the test script: not 3 parameters to test-expect-code"
209 say >&3 "expecting exit code $1: $3"
211 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
221 # Most tests can use the created repository, but some amy need to create more.
222 # Usage: test_create_repo <directory>
223 test_create_repo () {
225 error "bug in the test script: not 1 parameter to test-create-repo"
229 cd "$repo" || error "Cannot setup test environment"
230 "$GIT_EXEC_PATH/git" init --template=$GIT_EXEC_PATH/templates/blt/ >/dev/null 2>&1 ||
231 error "cannot run git init -- have you built things yet?"
232 mv .git/hooks .git/hooks-disabled
238 case "$test_failure" in
241 # cd .. && rm -fr trash
242 # but that means we forbid any tests that use their own
243 # subdirectory from calling test_done without coming back
244 # to where they started from.
245 # The Makefile provided will clean this test area so
246 # we will leave things as they are.
248 say "passed all $test_count test(s)"
252 say "failed $test_failure among $test_count test(s)"
258 # Test the binaries we have just built. The tests are kept in
259 # t/ subdirectory and are run in trash subdirectory.
261 GIT_EXEC_PATH=$(pwd)/..
262 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
263 GIT_CONFIG=.git/config
264 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG
266 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
268 test -d ../templates/blt || {
269 error "You haven't built things yet, have you?"
272 if ! test -x ../test-chmtime; then
273 echo >&2 'You need to build test-chmtime:'
274 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
281 test_create_repo $test
284 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
285 for skp in $GIT_SKIP_TESTS
288 for skp in $GIT_SKIP_TESTS
297 say >&3 "skipping test $this_test altogether"
298 say "skip all tests in $this_test"